
class differentialRobot extends robot {

   public differentialRobot() {
   }

   public differentialRobot(double x, double y, double theta, double linearVel, double angularVel) {
      super(x,y,theta,linearVel,angularVel);
   }

   public void computeDynamics(double step) {

      // Direct kinematics are compute for simulation porpuses

      double leftLinearVel = leftWheel.radious * leftWheel.vel;
      double rightLinearVel = rightWheel.radious * rightWheel.vel;
      double distanceBetweenWheels = rightWheel.distanceToCenter + leftWheel.distanceToCenter;

      double robotLinearVel = (leftLinearVel + rightLinearVel)/2.0;
      double robotAngularVel = (rightLinearVel - leftLinearVel)/(distanceBetweenWheels);

      // Robot movement along simulation
      currentPose.move(step,robotLinearVel,robotAngularVel);

      //System.out.print("Current position: " + currentPose.x + "," + currentPose.y + "," + currentPose.theta +'\t');
      //System.out.print("Current wVel: " + leftWheel.vel + "," + rightWheel.vel +'\n');
   }

   void computeInverseKinematics() {
      double distanceBetweenWheels = rightWheel.distanceToCenter + leftWheel.distanceToCenter;

      leftWheel.vel = (2.0*linearVelocity - angularVelocity * distanceBetweenWheels)
                        / (2.0*leftWheel.radious);
      rightWheel.vel = (2.0*linearVelocity + angularVelocity * distanceBetweenWheels)
                        / (2.0*rightWheel.radious);
   }

   wheel leftWheel = new wheel();
   wheel rightWheel = new wheel();
}
