
class pose {
   point2D p = new point2D();
   double theta = 0.0;
   pose base;
   scenario trajectories;
   boolean toogleTrajectoryPoint = true;

   public pose(){
   	p = new point2D();
   }

   public pose(pose in) {
   	p.x = in.p.x;
   	p.y = in.p.y;
   	theta = in.theta;
   	base = in.base;
   }

   public pose(pose p, pose base) {
   	this(p);
   	this.base = base;
   }

   public pose(point2D p, double theta) {
   	this.p.x = p.x;
   	this.p.y = p.y;
   	this.theta = theta;
   }

   public pose(double x, double y, double theta) {
   	this.p.x = x;
   	this.p.y = y;
   	this.theta = theta;
   }

   public void setBase(pose b) {
   	base = b;
   }

   public point2D getPoint(){
      return p;
   }

   public point2D transport(point2D p) {
   	point2D pt = new point2D();

   	double cos = Math.cos(theta);
   	double sin = Math.sin(theta);
   	pt.x = p.x*cos - p.y*sin + this.p.x;
   	pt.y = p.x*sin + p.y*cos + this.p.y;

   	return pt;
   }

   public point2D transportToBase(point2D p) {
   	p = transport(p);
   	return base.transport(p);
   }

   public void move(double step, double linearVelocity, double angularVelocity) {
      p.x += step*linearVelocity * Math.cos(theta);
      p.y += step*linearVelocity * Math.sin(theta);
      theta += step*angularVelocity;
   }

   public void storeTrajectory(boolean state){
      if (trajectories != null)
         trajectories.setPosition(p,state);
   }

   public void storeTrajectory(){
      if (trajectories != null) {
         trajectories.setPosition(p,toogleTrajectoryPoint);
         toogleTrajectoryPoint = !toogleTrajectoryPoint;
      }
   }

   public void storeTransportedTrajectory(point2D p, boolean state){
      if (trajectories != null) {
         trajectories.setPosition(transportToBase(p),state);
      }
   }

   public void storeTransportedTrajectory(point2D p){
      if (trajectories != null) {
         trajectories.setPosition(transportToBase(p),toogleTrajectoryPoint);
         toogleTrajectoryPoint = !toogleTrajectoryPoint;
      }
   }

   public boolean stillOnTrajectorySpace(){
      if (trajectories != null && (p.x < 0 || p.y < 0 || 
            p.x >= trajectories.getWidth() || 
            p.y >= trajectories.getHeight() ) )
         return false;
      else
         return true;
   }

   void setTrajectoryStorage(scenario sc){
      trajectories = sc;
   }
}
