
import java.util.*;

abstract class robot implements dynamicObject, activeObject, describableObject, leadToAbortObject{
   public robot() {
      currentPose = new pose();
   }

   public robot(pose p) {
      currentPose = p;
   }

   public robot(double x, double y, double theta, double linearVel, double angularVel) {
      currentPose = new pose(x,y,theta);
      linearVelocity = linearVel;
      angularVelocity = angularVel;
   }

   public void setPreDefActions() {
      predefActions =  new ArrayList<action>();
      predefActions.add((action) new move(30,1));
   }

   public void actuation(){
      perceive();
      decide();
      execute();
      otherUtilities();
   }

   public boolean evaluateAbort() {
      return !currentPose.stillOnTrajectorySpace();
   }

   public String getState() {
      return String.valueOf(currentPose.p.x)+",\t"+currentPose.p.y+",\t"+currentPose.theta;//+
      //",\t"+linearVelocity+",\t"+angularVelocity+(currentAction != null ? ",\tACT:"+currentAction.getName() : "");
   }

   public void attachSensor(sensor s) {
      if (sensors == null)
         sensors = new ArrayList<sensor>();
      s.setBase(currentPose);
      sensors.add(s);
   }

   void perceive() {
      // Compute sensing
   }

   void decide() {
      // Select current action
      // check for predefined actions first
      if(predefActions != null && !predefActions.isEmpty()) {
         if (currentAction == null) {
            currentAction = predefActions.get(0);
            predefActions.remove(0);
         }
      }
      // otherwise, if its time to decide, do:
      else if (currentAction == null || currentAction.isStopable()) {
         proximitySensor s = (proximitySensor) sensors.get(0);

         // To be coded (use sensor sample to decide what to do)

      }
   }

   void execute() {
      // Performs action until it ends
      linearVelocity = currentAction.linearVelocity;
      angularVelocity = currentAction.angularVelocity;

      // Initializing action
      if (!currentAction.hasStarted()) {
         currentAction.start(currentPose);
      }

      // Forces to stop if the action is done
      if (currentAction.isDone(currentPose)) {
         currentAction = (action) new stop();
      }
      // Set wheel speeds by computing inverse kinematics
      computeInverseKinematics();

      // Takes out current action to continue when deciding
      if (currentAction.isDone(currentPose)) {
         currentAction = null;
      }
   }

   void otherUtilities(){
      // To be coded
      // Made for storing trajectory here    
   }

   public void setTrajectoryStorage(scenario sc){
      currentPose.setTrajectoryStorage(sc);
   }

   abstract void computeInverseKinematics();
      
   ArrayList<action> predefActions;
   ArrayList<sensor> sensors;
   pose currentPose = new pose(0,0,0);
   double linearVelocity;
   double angularVelocity;
   action currentAction;
}



abstract class action {
   double linearVelocity;
   double angularVelocity;
   boolean started = false;
   boolean stopable = false;
   String name = "";

   public abstract boolean isDone(pose p);

   public void start(pose startingPose) {
      started = true;
   }

   public boolean hasStarted() {
      return started;
   }

   public boolean isStopable() {
      return stopable;
   }

   public String getName() {
      return name;
   }
}

class turn extends action {
   public turn(double turningTheta) {
      linearVelocity = 0.0;
      angularVelocity = 0.1*Math.PI;
      if (turningTheta < 0)
         angularVelocity *= -1;

      turningAngle = Math.abs(turningTheta) % (2.0*Math.PI);
      name = "TURN" + (Math.signum(turningTheta)>0? "+" + turningTheta :  turningTheta);
   }

   public void start(pose startingPose) {
      super.start(startingPose); 
      theta_0 = startingPose.theta;
   }

   public boolean isDone(pose p) {
      double angleDiff = Math.PI - Math.abs((Math.abs(p.theta - theta_0) % (2.0*Math.PI)) - Math.PI); 
      if (angleDiff >= turningAngle)
         return true;
      else 
         return false;
   }

   double theta_0;
   double turningAngle;
}

class move extends action {
   public move(double distance, double vel) {
      linearVelocity = vel;
      angularVelocity = 0.0;
      movingDistance = distance;
      stopable = true;
      name = "MOVE" + (Math.signum(vel)>0? "+"  + distance : distance);
   }

   public void start(pose startingPose) {
      super.start(startingPose);
      x_0 = startingPose.p.x;
      y_0 = startingPose.p.y;
   }

   public boolean isDone(pose p) {
      if (Math.hypot(p.p.x-x_0,p.p.y-y_0)>=movingDistance)
         return true;
      else 
         return false;
   }

   double x_0;
   double y_0;
   double movingDistance;
}

class stop extends action {
   public stop() { 
      name = "STOP";
   }
   public boolean isDone(pose p) {
      return true;
   }
}