import java.util.*;

abstract class sensor {
	pose pos; // Relative pose  --> with respect the robot
	ArrayList<Double> samples;

	public sensor() {
		pos = new pose();
	}
	
	public sensor(pose sensorPose, pose basePose) {
		pos = new pose(sensorPose,basePose);
	}

	public sensor(pose sensorPose) {
		pos = new pose(sensorPose);
	}

	public sensor(Double x, double y, double theta) {
		pos = new pose(x,y,theta);
	}

	public void setBase(pose base){
		pos.setBase(base);
	}

    public void setTrajectoryStorage(scenario sc){
      pos.setTrajectoryStorage(sc);
   }

	public ArrayList<Double> getSamples() {
		return samples;
	}

	public double getSample() {
		if (!samples.isEmpty())
			return samples.get(0);
		return -1.0;
	}

	public double retreiveSample() {
		if (!samples.isEmpty()) {
			double s = samples.get(0);
			samples.remove(0);
			return s;
		}
		return -1.0;
	}
}