import java.util.*;


class simulator {

	public void addDynamicObject(Object o) {
		if (o instanceof dynamicObject)
			dynamicObjects.add((dynamicObject)o);
	}

	public void addActiveObject(Object o) {
		if (o instanceof activeObject)
			activeObjects.add((activeObject)o);
	}

	public void addDescribableObject(Object o) {
		if (o instanceof describableObject)
			describableObjects.add((describableObject)o);
	}

	public void addCollidableObject(Object o) {
		if (o instanceof collidableObject)
			collidableObjects.add((collidableObject)o);
	}

	public void addLeadToAbortObject(Object o) {
		if (o instanceof leadToAbortObject)
			leadToAbortObjects.add((leadToAbortObject)o);
	}
	public void run(double duration) {

		while (!abort && currentTime < duration) {
			evaluateAborts();
			streamOutCurrentDescriptions();
			computeCollisions();
			computeActuations();
			computeDynamics();
			currentTime += timeStep;
		}
	}

	void computeCollisions() {
		if (collidableObjects.size() > 1) {
			for (collidableObject colObj1 : collidableObjects) {
				List<collidableObject> otherColl = collidableObjects.subList(
						collidableObjects.indexOf(colObj1),
						collidableObjects.size());
				if (otherColl.size() > 0)
					for (collidableObject colObj2 : collidableObjects)
						colObj1.computeCollision(colObj2);
			}
		}
	}


	void computeDynamics() {
		for (dynamicObject dynObj : dynamicObjects) {
			dynObj.computeDynamics(timeStep);
		}

	}

	void computeActuations() {
		for (activeObject actObj : activeObjects) {
			actObj.actuation();
		}

	}

	void evaluateAborts() {
		for (leadToAbortObject abortObj : leadToAbortObjects) {
			if (abortObj.evaluateAbort()) {
				System.out.println("Early end of simulation at " + currentTime + "[s] by a(n) "+abortObj.getClass().getName()+" object.\n");
				abort = true;
			}
		}

	}

	void streamOutCurrentDescriptions() {

		System.out.print(currentTime);
		System.out.print(",\t");
		for (describableObject descObj : describableObjects) {
			System.out.print(descObj.getState());
		}
		System.out.print("\n");
	}

	ArrayList<dynamicObject> dynamicObjects = new ArrayList<dynamicObject>();
	ArrayList<activeObject> activeObjects = new ArrayList<activeObject>();
	ArrayList<describableObject> describableObjects = new ArrayList<describableObject>();
	ArrayList<collidableObject> collidableObjects = new ArrayList<collidableObject>();
	ArrayList<leadToAbortObject> leadToAbortObjects = new ArrayList<leadToAbortObject>();
	double timeStep = 0.01;
	double currentTime = 0.0;
	boolean abort = false;

}
