// TO_DO Fix maze rotation

import java.io.*;
import java.util.*;

class stage3 {
	static scenario scene;
	static double duration;
	static String outputFile = "output.pbm";
	
	public static void main (String[] args)  throws IOException  {
		robot rob = new differentialRobot(0,21,0,3,0);
		simulator sim = new simulator();

		sensor s = (sensor) new proximitySensor(1,0,0,4);
		rob.attachSensor(s);

		defaultArgs(args);

		Maze trajectory = new Maze(scene);
		rob.setTrajectoryStorage(trajectory);
		s.setTrajectoryStorage(trajectory);

		sim.addDynamicObject(rob);
		sim.addActiveObject(rob);
		sim.addDescribableObject(rob);
		sim.addLeadToAbortObject(rob);
		sim.addCollidableObject(s);
		sim.addCollidableObject(scene);

		// rob.setPreDefActions();

		sim.run(duration);
		trajectory.write(new PrintStream(outputFile));
	}

	static void defaultArgs(String[] args)  throws IOException  {
		if(args.length > 2)
        	duration = Double.parseDouble(args[2]);
      	else
      		duration = 60;

		if(args.length > 0){ 
			Scanner sc = new Scanner(new File(args[0]));
        	scene = (scenario) new Maze(sc);
		}
      	else {
      		String defFile = "simple_maze.pbm";
			Scanner sc = new Scanner(new File(defFile));
      		scene = (scenario) new Maze(sc);
      	}
      	
      	if(args.length > 1)
			outputFile = args[1];

	}
}